/*residencePro.java
 *06/3/28
 *javaScript
 *2024/12/07
 *Suzuki,Tetsuo 鈴木徹夫
 */

const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");
let pn=1005;
let qn=100;
let n;
let k=0;//もう１つの粒子　今は　なし。
let me=0,mme=0;
let ct1=0;
let x=[];//pn
let y=[];
let dx=[];
let dy=[];
let r=[];
let m=[];
let fl=[];//[][]
let gfy=[];//[qn];
let gty=[];
let ct=[];
let i,j,me1,me2,e1,e2,flag1,flag2,flag3,pe1,pe2,spe1,sspe1,ee1,dh,
         ee2,bgx,bgy,rgy,rrgy,bp1,bbp1,rp1,rrp1,bbgy;
let red,green,blue;
let gv;

let d = { width: canvas.width, height: canvas.height };


function init() {
        for(i=0;i<100;i++){gfy[i]=0;gty[i]=0;ct[i]=0;}
		flag1=0;flag2=0;flag3=0; me=0;bgx=0;bgy=0;rgy=0; bbgy=0;rrgy=0;     
		bbp1=0;bp1=0;rp1=0;rrp1=0;gv=0.5;n=100;
		buffer = createBuffer(d.width, d.height);
		drawToBuffer();
		for(i=0;i<k;i++){
			r[i]=30;//今回、なし。
			m[i]=2;
			}
		for(i=k;i<n;i++){
			r[i]=6;
			m[i]=1;
			}
		for(i=0;i<n;i++){ 
			x[i]=50+(Math.random()*(150-2*r[i]));
			y[i]=(3*d.height/5+Math.random()*(2*d.height/5-2*r[i]))-30;
	       	dx[i]=(Math.random()*4);
			if (1==Math.floor(Math.random()*3)) dx[i]=-dx[i];
	       		dy[i]=(Math.random()*4);
			if (1==Math.floor(Math.random()*3)) dy[i]=-dy[i];
		        	}
		me1=0;me2=0;
	}



function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
	    g.fillStyle = "white";
		g.fillRect(0,0,d.width,d.height)
        
		g.fillStyle = "lightGray";//筒
		g.fillRect(40,0,10,d.height-20);
		g.fillRect(200,0,10,d.height-20);
		g.fillRect(50,d.height-30,150,10);
		
		g.strokeStyle = "black"; 
        g.beginPath();
		g.moveTo(230,50);//矢印
        g.lineTo(230,d.height-30);
		g.moveTo(230,50);
        g.lineTo(230-5,50+5);
		g.moveTo(230,50);
        g.lineTo(230+5,50+5);
		g.stroke();
		
		g.fillStyle = "black"; 
		g.fillText("   y",530,d.height-30+10);//グラフ
		g.fillText("F(y)",275,280);
		g.fillText("0",280,d.height-30+10);
		g.fillText("10",330,d.height-30+10);
		g.fillText("20",380,d.height-30+10);
		g.fillText("30",430,d.height-30+10);
		g.fillText("40",480,d.height-30+10);

		g.fillText("0",235,d.height-30);//高さ目盛
		g.fillText("10",235,d.height-30-100);
		g.fillText("20",235,d.height-30-200);
		g.fillText("30",235,d.height-30-300);
		g.fillText("40",235,d.height-30-400);
		g.fillText("y",235,d.height-30-490);

		g.fillText("number of particles",350,d.height-30-400);
		g.fillText("gravitational acceleration",350,d.height-30-370);
		g.fillText("residence probability F(y) for large number",350,d.height-30-340);
		
		g.fillStyle = "blue"; 
		g.fillText("n="+n,350,d.height-30-385);
		g.fillText(2*gv+"g",350,d.height-30-355);
		g.fillText("F(y)=A*exp( -mgy / kT )",350,d.height-30-325);
		
		 if(flag2==0){
                g.fillStyle = "magenta";
			for(i=0;i<100;i++){
                g.fillRect(280+5*i,d.height-30-gfy[i],5,gfy[i]);
                              }
            		}
		
		g.strokeStyle = "black"; 
	         if(me!=0){
			 for(i=0;i<90;i++){
				 g.beginPath();
		         g.moveTo(280+5*i,d.height-30-(gty[i]/me));
                 g.lineTo(280+5*i+5,d.height-30-(gty[i+1]/me));
				 g.stroke();
		    		}
				}
		g.strokeStyle = "black"; 
        g.beginPath();
		g.moveTo(280,300);//グラフ縦軸
        g.lineTo(280,d.height-30);
		g.moveTo(280,d.height-30);//横軸	
        g.lineTo(550,d.height-30);
		g.stroke();	
		
		g.fillStyle = "cyan";
	    for(i=0;i<k;i++){
	    g.beginPath();
        g.arc(x[i]+r[i], y[i]+r[i], r[i], 0, Math.PI * 2);
        g.fill();
		}
		
		g.fillStyle = "blue";
	    for(i=k;i<n;i++){
	    g.beginPath();
        g.arc(x[i]+r[i], y[i]+r[i], r[i], 0, Math.PI * 2);
        g.fill();
		}
}


function move() {
	    let bx=[];//[pn];
		let by=[];
		let bdx=[];
		let bdy=[];
		let b,a,aa,bb,dd,bdd;
		let s,t,p,q,u,v;
		let ij;	
	
	    for(i=0;i<n;i++){			
			if(y[i]>d.height-2*r[i]-30-10)ct[0]=ct[0]+1;
			else if(y[i]>d.height-2*r[i]-30-20)ct[1]=ct[1]+1;
			else if(y[i]>d.height-2*r[i]-30-30)ct[2]=ct[2]+1;
			else if(y[i]>d.height-2*r[i]-30-40)ct[3]=ct[3]+1;
			else if(y[i]>d.height-2*r[i]-30-50)ct[4]=ct[4]+1;
			else if(y[i]>d.height-2*r[i]-30-60)ct[5]=ct[5]+1;
			else if(y[i]>d.height-2*r[i]-30-70)ct[6]=ct[6]+1;
			else if(y[i]>d.height-2*r[i]-30-80)ct[7]=ct[7]+1;
			else if(y[i]>d.height-2*r[i]-30-90)ct[8]=ct[8]+1;
			else if(y[i]>d.height-2*r[i]-30-100)ct[9]=ct[9]+1;
			else if(y[i]>d.height-2*r[i]-30-110)ct[10]=ct[10]+1;
			else if(y[i]>d.height-2*r[i]-30-120)ct[11]=ct[11]+1;
			else if(y[i]>d.height-2*r[i]-30-130)ct[12]=ct[12]+1;
			else if(y[i]>d.height-2*r[i]-30-140)ct[13]=ct[13]+1;
			else if(y[i]>d.height-2*r[i]-30-150)ct[14]=ct[14]+1;
			else if(y[i]>d.height-2*r[i]-30-160)ct[15]=ct[15]+1;
			else if(y[i]>d.height-2*r[i]-30-170)ct[16]=ct[16]+1;
			else if(y[i]>d.height-2*r[i]-30-180)ct[17]=ct[17]+1;
			else if(y[i]>d.height-2*r[i]-30-190)ct[18]=ct[18]+1;
			else if(y[i]>d.height-2*r[i]-30-200)ct[19]=ct[19]+1;
			else if(y[i]>d.height-2*r[i]-30-210)ct[20]=ct[20]+1;
			else if(y[i]>d.height-2*r[i]-30-220)ct[21]=ct[21]+1;
			else if(y[i]>d.height-2*r[i]-30-230)ct[22]=ct[22]+1;
			else if(y[i]>d.height-2*r[i]-30-240)ct[23]=ct[23]+1;
			else if(y[i]>d.height-2*r[i]-30-250)ct[24]=ct[24]+1;
			else if(y[i]>d.height-2*r[i]-30-260)ct[25]=ct[25]+1;
			else if(y[i]>d.height-2*r[i]-30-270)ct[26]=ct[26]+1;
			else if(y[i]>d.height-2*r[i]-30-280)ct[27]=ct[27]+1;
			else if(y[i]>d.height-2*r[i]-30-290)ct[28]=ct[28]+1;
			else if(y[i]>d.height-2*r[i]-30-300)ct[29]=ct[29]+1;
			else if(y[i]>d.height-2*r[i]-30-310)ct[30]=ct[30]+1;
			else if(y[i]>d.height-2*r[i]-30-320)ct[31]=ct[31]+1;
			else if(y[i]>d.height-2*r[i]-30-330)ct[32]=ct[32]+1;
			else if(y[i]>d.height-2*r[i]-30-340)ct[33]=ct[33]+1;
			else if(y[i]>d.height-2*r[i]-30-350)ct[34]=ct[34]+1;
			else if(y[i]>d.height-2*r[i]-30-360)ct[35]=ct[35]+1;
			else if(y[i]>d.height-2*r[i]-30-370)ct[36]=ct[36]+1;
			else if(y[i]>d.height-2*r[i]-30-380)ct[37]=ct[37]+1;
			else if(y[i]>d.height-2*r[i]-30-390)ct[38]=ct[38]+1;
			else if(y[i]>d.height-2*r[i]-30-400)ct[39]=ct[39]+1;
			else if(y[i]>d.height-2*r[i]-30-410)ct[40]=ct[40]+1;
			else if(y[i]>d.height-2*r[i]-30-420)ct[41]=ct[41]+1;
			else if(y[i]>d.height-2*r[i]-30-430)ct[42]=ct[42]+1;
			else if(y[i]>d.height-2*r[i]-30-440)ct[43]=ct[43]+1;
			else if(y[i]>d.height-2*r[i]-30-450)ct[44]=ct[44]+1;
			else if(y[i]>d.height-2*r[i]-30-460)ct[45]=ct[45]+1;
			else if(y[i]>d.height-2*r[i]-30-470)ct[46]=ct[46]+1;
			else if(y[i]>d.height-2*r[i]-30-480)ct[47]=ct[47]+1;
			else if(y[i]>d.height-2*r[i]-30-490)ct[48]=ct[48]+1;
			else if(y[i]>d.height-2*r[i]-30-500)ct[49]=ct[49]+1;
			else if(y[i]>d.height-2*r[i]-30-510)ct[50]=ct[50]+1;
			else if(y[i]>d.height-2*r[i]-30-520)ct[51]=ct[51]+1;
			else if(y[i]>d.height-2*r[i]-30-530)ct[52]=ct[52]+1;
			else if(y[i]>d.height-2*r[i]-30-540)ct[53]=ct[53]+1;
			else if(y[i]>d.height-2*r[i]-30-550)ct[54]=ct[54]+1;
			else if(y[i]>d.height-2*r[i]-30-560)ct[55]=ct[55]+1;
			else if(y[i]>d.height-2*r[i]-30-570)ct[56]=ct[56]+1;
			else if(y[i]>d.height-2*r[i]-30-580)ct[57]=ct[57]+1;
			else if(y[i]>d.height-2*r[i]-30-590)ct[58]=ct[58]+1;
			else if(y[i]>d.height-2*r[i]-30-600)ct[59]=ct[59]+1;
			else if(y[i]>d.height-2*r[i]-30-610)ct[60]=ct[60]+1;
			else if(y[i]>d.height-2*r[i]-30-620)ct[61]=ct[61]+1;
			else if(y[i]>d.height-2*r[i]-30-630)ct[62]=ct[62]+1;
			else if(y[i]>d.height-2*r[i]-30-640)ct[63]=ct[63]+1;
        	}

	        for(i=0;i<100;i++){
			gfy[i]=500*ct[i]/n;        //300
		        gty[i]=gty[i]+flag1*gfy[i];
				}
			for(i=0;i<100;i++){
			ct[i]=0;
			}
			
			me=me+flag1*1;//flag1;
	        mme=mme+1;
			for(i=0;i<n;i++){
			bx[i]=x[i];
			by[i]=y[i];
			dy[i]=dy[i]+flag1*gv;
			bdx[i]=dx[i];
			bdy[i]=dy[i];
		
			x[i]=x[i]+flag1*dx[i];
			y[i]=y[i]+flag1*dy[i];
		if (x[i]<50){
                   x[i]=50;//-x[i];
                  dx[i]=-dx[i];	bdx[i]=dx[i];}
		if (x[i]>=200-2*r[i]){
			x[i]=200-2*r[i]; 
			dx[i]=-dx[i];	bdx[i]=dx[i];}
	
	
		if (y[i]>d.height-30-2*r[i]) {
			y[i]=y[i]-dy[i];
			dy[i]=-dy[i];
        	bdy[i]=dy[i];
              }
			}
			
		for ( i = 0; i < n; i++) {
          fl[i] = [];
        for ( j = 0; j < n; j++) {
           fl[i][j] = 1;
         }
         }	
			
		
		for(i=0;i<n;i++){
		for(j=0;j<n;j++){
			a=x[j]-x[i]+r[j]-r[i] ;
			aa=bx[j]-bx[i]+r[j]-r[i];
			b=y[j]-y[i]+r[j]-r[i] ;
			bb=by[j]-by[i]+r[j]-r[i];
			dd=a*a+b*b;
			bdd=aa*aa+bb*bb;
		if (dd!=0&&dd<=(r[i]+r[j])*(r[i]+r[j])&&j!=i
            &&dd<bdd&&fl[i][j]==1)
            {
			s=(m[i]-m[j])/(m[i]+m[j]);
			t=2*m[j]/(m[i]+m[j]);
			p=(a*bdy[i]-b*bdx[i]);
	   	    q=(s*(a*bdx[i]+b*bdy[i])+t*(a*bdx[j]+b*bdy[j]));
			u=(a*q-b*p)/dd;
			v=(b*q+a*p)/dd;
	
			dx[i]=u;
	        dy[i]=v;    //-1
		
			for(ij=0;ij<n;ij++){
				fl[i][ij]=0;
				fl[ij][i]=0;
				fl[ij][j]=0;
				fl[j][i]=1;
				}
			j=n;
			}
			}
		}
	}
	
	
function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }   , 30); 
}

document.getElementById('n2').addEventListener('click', n2);
document.getElementById('n5').addEventListener('click', n5);
document.getElementById('n100').addEventListener('click', n100);
document.getElementById('n500').addEventListener('click', n500);
document.getElementById('g1').addEventListener('click', g1);
document.getElementById('g03').addEventListener('click', g03);
document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Stop').addEventListener('click', Stop);
document.getElementById('Reset').addEventListener('click', Reset);




function n2() {       
		flag1=0;flag2=0;bgx=0;bgy=0;rgy=0;flag3=0;n=2;
					me1=0;k=0;bbgy=0;rrgy=0;ct1=0;bbp1=0;bp1=0;rp1=0;rrp1=0;
 			        me2=0;me=0;mme=0;pe1=0;pe2=0;ee1=0;ee2=0;
						for(i=0;i<k;i++){
			r[i]=6;
			m[i]=1;
			}
		for(i=k;i<n;i++){
			r[i]=10;
			m[i]=5;
			
			}
		for(i=0;i<100;i++){gfy[i]=0;gty[i]=0;ct[i]=0;}
		for(i=0;i<n;i++){ 
		
			x[i]=50+(Math.random()*(150-2*r[i]));
			y[i]=(4*(d.height-30)/5-25+Math.random()*50);
	       	dx[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dx[i]=-dx[i];
	       		dy[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dy[i]=-dy[i];
		        	}				
}

function n5() {
       flag1=0;flag2=0;bgx=0;bgy=0;rgy=0;flag3=0;n=5;
					me1=0;k=0;bbgy=0;rrgy=0;ct1=0;bbp1=0;bp1=0;rp1=0;rrp1=0;
 			        me2=0;me=0;mme=0;pe1=0;pe2=0;ee1=0;ee2=0;
						for(i=0;i<k;i++){
			r[i]=6;
			m[i]=1;
			}
			for(i=0;i<100;i++){gfy[i]=0;gty[i]=0;ct[i]=0;}
		for(i=k;i<n;i++){
			
			r[i]=6;
			m[i]=5;
			}
		for(i=0;i<n;i++){ 
			x[i]=50+(Math.random()*(150-2*r[i]));
			y[i]=(4*(d.height-30)/5-25+Math.random()*50);
	       	dx[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dx[i]=-dx[i];
	       		dy[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dy[i]=-dy[i];
		        	}
}
function n100() {
         flag1=0;flag2=0;bgx=0;bgy=0;rgy=0;flag3=0;n=100;
					me1=0;k=0;bbgy=0;rrgy=0;ct1=0;bbp1=0;bp1=0;rp1=0;rrp1=0;
 			        me2=0;me=0;mme=0;pe1=0;pe2=0;ee1=0;ee2=0;
						for(i=0;i<k;i++){
			r[i]=6;
			m[i]=1;
			}
		for(i=0;i<100;i++){gfy[i]=0;gty[i]=0;ct[i]=0;}
		for(i=k;i<n;i++){
			
			r[i]=6;
			m[i]=5;
			}
		for(i=0;i<n;i++){ 
			x[i]=50+(Math.random()*(150-2*r[i]));
			y[i]=(3*d.height/5+Math.random()*(2*d.height/5-2*r[i]))-30;
	       	dx[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dx[i]=-dx[i];
	       		dy[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dy[i]=-dy[i];
	
	        	} 
				
}
function n500() {
       flag1=0;flag2=0;bgx=0;bgy=0;rgy=0;flag3=0;n=500;
					me1=0;k=0;bbgy=0;rrgy=0;ct1=0;bbp1=0;bp1=0;rp1=0;rrp1=0;
 			        me2=0;me=0;mme=0;pe1=0;pe2=0;ee1=0;ee2=0;
						for(i=0;i<k;i++){
			r[i]=6;
			m[i]=1;
			}
		for(i=0;i<100;i++){gfy[i]=0;gty[i]=0;ct[i]=0;}
		for(i=k;i<n;i++){
			
			r[i]=3;
			m[i]=5;
			}
		for(i=0;i<n;i++){ 
			x[i]=50+(Math.random()*(150-2*r[i]));
			y[i]=(3*d.height/5+Math.random()*(2*d.height/5-2*r[i]))-30;
	       	dx[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dx[i]=-dx[i];
	       		dy[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dy[i]=-dy[i];	
	        	}
			
		
}
function g1() {
        gv=0.5;
		
}

function g03() {
           gv=0.15;
}
function Run() {
            flag1=1;flag2=0;			
}
function Stop() {
        flag1=0;bbgy=0;rrgy=0;bgx=1000;flag2=1;
		ct1=0;
}
function Reset() {
        flag1=0;flag2=0;bgx=0;bgy=0;rgy=0;flag3=0;
					me1=0;k=0;bbgy=0;rrgy=0;ct1=0;bbp1=0;bp1=0;rp1=0;rrp1=0;
 			        me2=0;mme=0;pe1=0;pe2=0;ee1=0;ee2=0;
				me=0;
						for(i=0;i<k;i++){
			}
		for(i=k;i<n;i++){
		
			}
		for(i=0;i<100;i++){gfy[i]=0;gty[i]=0;ct[i]=0;}
		for(i=0;i<n;i++){ 
			x[i]=50+(Math.random()*(150-2*r[i]));
			y[i]=(3*d.height/5+Math.random()*(2*d.height/5-2*r[i]))-30;
	       	dx[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dx[i]=-dx[i];
	       		dy[i]=(Math.random()*4);
			if (0==Math.floor(Math.random()*2)) dy[i]=-dy[i];	
	        	}          
}


init();
start();